import java.util.Scanner;

public class BST_7
{
    public static void main( String[] args )
    {
        BST_7 bst = new BST_7();
        bst.solve();
    }

    private void solve()
    {
        Scanner scan = new Scanner( System.in );
        int numCases = scan.nextInt();
        for ( int c = 1; c <= numCases; c++ )
        {
            int nums = scan.nextInt();
            Node root = null;
            for ( int n = 0; n < nums; n++ )
                root = insertTree( scan.nextInt(), root );
                
            System.out.printf( "Case %d: %d\n", c, height( root ) );
        }
    }

    private int height( Node n )
    {
        if ( n == null )
            return -1;
            
        int rightHeight = 1 + height( n.right );
        int leftHeight = 1 + height( n.left );
        return Math.max( rightHeight, leftHeight );
    }

    private Node insertTree( int i, Node n )
    {
        if ( n == null )
            return new Node( i );
        else if ( i < n.data )
            n.left = insertTree( i, n.left );
        else if ( i > n.data )
            n.right = insertTree( i, n.right );

        return n;
    }

    private class Node
    {
        int data;
        Node left, right;

        public Node( int i )
        {
            data = i;
        }
    }
}
