import java.util.Scanner;

public class MICSL_5
{
    private final char[][] iArr = { { 'I', 'I', 'I', 'I', 'I' },
                                    { ' ', ' ', 'I', ' ', ' ' },
                                    { ' ', ' ', 'I', ' ', ' ' },
                                    { ' ', ' ', 'I', ' ', ' ' },
                                    { 'I', 'I', 'I', 'I', 'I' },
                                    { ' ', ' ', ' ', ' ', ' ' } };

    private final char[][] cArr = { { 'C', 'C', 'C', 'C', 'C' },
                                    { 'C', ' ', ' ', ' ', ' ' },
                                    { 'C', ' ', ' ', ' ', ' ' },
                                    { 'C', ' ', ' ', ' ', ' ' },
                                    { 'C', 'C', 'C', 'C', 'C' },
                                    { ' ', ' ', ' ', ' ', ' ' } };

    private final char[][] sArr = { { 'S', 'S', 'S', 'S', 'S' },
                                    { 'S', ' ', ' ', ' ', ' ' },
                                    { 'S', 'S', 'S', 'S', 'S' },
                                    { ' ', ' ', ' ', ' ', 'S' },
                                    { 'S', 'S', 'S', 'S', 'S' } };

    public static void main( String[] args )
    {
        MICSL_5 mics = new MICSL_5();
        mics.solve();
    }

    private void solve()
    {
        Scanner scan = new Scanner( System.in );
        int numCases = scan.nextInt();
        for ( int c = 1; c <= numCases; c++ )
        {
            System.out.printf( "Case %d:\n", c );
            int scale = scan.nextInt();
            drawM( scale );
            drawIC( iArr, scale );
            drawIC( cArr, scale );
            drawS( scale );
        }
        scan.close();
    }

    // This letter is the least-fun part of this whole deal.
    private void drawM( int scale )
    {
        int size = scale * 5;
        int l_width = scale * 20;
        int solidWide = scale;
        int row = 0;
        while ( solidWide <= 2 * scale )
        {
            int centerGap = size - 2 * solidWide;
            for ( int m = 0; m < solidWide; m++ )
                System.out.print( "M" );
            for ( int m = 0; m < centerGap; m++ )
                System.out.print( " " );
            for ( int m = 0; m < solidWide; m++ )
                System.out.print( "M" );
            for ( int gap = 0; gap < size; gap++ )
                System.out.print( " " );
            for ( int l = 0; l < l_width; l++ )
            {
                if ( l < scale )
                    System.out.print( "L" );
                else
                    System.out.print( " " );
            }       
            System.out.println();
            
            solidWide++ ;
            row++ ;
        }

        int centerPiece = size - 2 * scale - 2;
        while ( centerPiece > 0 )
        {
            int space = ( size - centerPiece - 2 * scale ) / 2;
            for ( int m = 0; m < scale; m++ )
                System.out.print( "M" );
            for ( int m = 0; m < space; m++ )
                System.out.print( " " );

            if ( centerPiece > 2 * scale )
            {
                int centerGap = centerPiece - 2 * scale;
                for ( int m = 0; m < scale; m++ )
                    System.out.print( "M" );
                for ( int m = 0; m < centerGap; m++ )
                    System.out.print( " " );
                for ( int m = 0; m < scale; m++ )
                    System.out.print( "M" );
            }
            else
            {
                for ( int m = 0; m < centerPiece; m++ )
                    System.out.print( "M" );
            }
            for ( int m = 0; m < space; m++ )
                System.out.print( " " );
            for ( int m = 0; m < scale; m++ )
                System.out.print( "M" );
            for ( int gap = 0; gap < size; gap++ )
                System.out.print( " " );
            for ( int l = 0; l < l_width; l++ )
            {
                if ( l < scale )
                    System.out.print( "L" );
                else
                    System.out.print( " " );
            }
            System.out.println();

            centerPiece -= 2;
            row++ ;
        }

        for ( int r = row; r < size; r++ )
        {
            int space = size - 2 * scale;
            for ( int m = 0; m < scale; m++ )
                System.out.print( "M" );
            for ( int m = 0; m < space; m++ )
                System.out.print( " " );
            for ( int m = 0; m < scale; m++ )
                System.out.print( "M" );
            for ( int gap = 0; gap < size; gap++ )
                System.out.print( " " );
            for ( int l = 0; l < l_width; l++ )
            {
                if ( l < scale )
                    System.out.print( "L" );
                else
                    System.out.print( " " );
            }
            System.out.println();
        }

        for ( int r = 0; r < scale; r++ )
        {
            for ( int c = 0; c < 2 * size; c++ )
                System.out.print( " " );
            for ( int l = 0; l < l_width; l++ )
            {
                if ( l < scale )
                    System.out.print( "L" );
                else
                    System.out.print( " " );
            }
            System.out.println();
        }
    }

    private void drawIC( char[][] letter, int scale )
    {
        int height = scale * 6;
        int width = scale * 5;
        int l_width = scale * 20;
        for ( int row = 0; row < height; row++ )
        {
            for ( int col = 0; col < width; col++ )
                System.out.print( letter[row / scale][col / scale] );
            for ( int gap = 0; gap < width; gap++ )
                System.out.print( " " );
            for ( int l = 0; l < l_width; l++ )
            {
                if ( l < scale )
                    System.out.print( "L" );
                else
                    System.out.print( " " );
            }
            System.out.println();
        }
    }

    private void drawS( int scale )
    {
        int size = scale * 5;
        int l_width = scale * 20;
        for ( int row = 0; row < size; row++ )
        {
            for ( int col = 0; col < size; col++ )
                System.out.print( sArr[row / scale][col / scale] );
            for ( int gap = 0; gap < size; gap++ )
                System.out.print( " " );
            for ( int l = 0; l < l_width; l++ )
            {
                boolean inBottomRow = row / scale == sArr.length - 1;
                if ( inBottomRow || l < scale )
                    System.out.print( "L" );
                else
                    System.out.print( " " );
            }
            System.out.println();
        }
    }
}
