import java.math.BigInteger;
import java.util.*;

public class Routes_3
{
    public static void main( String[] args )
    {
        Routes_3 routes = new Routes_3();
        routes.solve();
    }

    private void solve()
    {
        Scanner scan = new Scanner( System.in );
        int numCases = scan.nextInt();
        for ( int c = 1; c <= numCases; c++ )
        {
            int width = scan.nextInt();
            int height = scan.nextInt();
            int min = Math.min( width, height );
            long routes = choose( width + height, min );
            System.out.printf( "Case %d: %d\n", c, routes );
        }
        scan.close();
    }
   
    private long choose( int x, int y )
    {
        BigInteger numerator = partFactorial((x - y) + 1, x);
        BigInteger denominator = partFactorial(1,y);
        BigInteger choose = numerator.divide( denominator );   
        return choose.longValue();
    }
    
    private BigInteger partFactorial( int n1, int n2 )
    {
        BigInteger fact = BigInteger.ONE;
        for ( int i = n1; i <= n2; i++ )
            fact = fact.multiply( BigInteger.valueOf( i ) );
            
        return fact;
    }

}
