import java.util.*;

public class Zukei_2
{
    private Point[] points;

    public static void main( String[] args )
    {
        Zukei_2 zk = new Zukei_2();
        zk.solve();
    }

    private void solve()
    {
        Scanner scan = new Scanner( System.in );
        int numCases = scan.nextInt();
        for ( int c = 1; c <= numCases; c++ )
        {
            int numPoints = scan.nextInt();
            points = new Point[numPoints];
            for ( int p = 0; p < points.length; p++ )
            {
                points[p] = new Point( scan.nextInt(), scan.nextInt() );
            }
            Arrays.sort( points );
            Point[] rect = findRectangle();

            System.out.printf( "Case %d:", c );
            Arrays.sort( rect, this::finalSort );
            for ( Point pt : rect )
            {
                System.out.printf( " %d %d", pt.x, pt.y );
            }
            System.out.println();
        }
        scan.close();
    }

    private Point[] findRectangle()
    {
        Point[] rect = new Point[4];
        for ( int p1 = 0; p1 <= points.length - 4; p1++ )
        {
            rect[0] = points[p1];
            for ( int p2 = p1 + 1; p2 <= points.length - 3; p2++ )
            {
                if ( points[p2].y == points[p1].y )
                {
                    rect[1] = points[p2];
                    for ( int p3 = p2 + 1; p3 <= points.length - 2; p3++ )
                    {
                        if ( points[p3].x == points[p2].x )
                        {
                            rect[2] = points[p3];
                            for ( int p4 = 0; p4 < points.length; p4++ )
                            {
                                // 7-Deep Nesting!  Yee-haw, it's the Wild Wild West!
                                if ( points[p4].x == points[p1].x &&
                                     points[p4].y == points[p3].y )
                                {
                                    rect[3] = points[p4];
                                    return rect;
                                }
                            }
                        }
                    }
                }
            }
        }

        System.out.println( "HERE" );
        return rect;
    }

    private int finalSort( Point p1, Point p2 )
    {
        if ( p1.y == p2.y )
            return p1.x - p2.x;
            
        return p1.y - p2.y;
    }

    private class Point implements Comparable<Point>
    {
        private int x;
        private int y;

        private Point( int x_, int y_ )
        {
            x = x_;
            y = y_;
        }

        public int compareTo( Point o )
        {
            return this.y - o.y;
        }
    }
}
