"""
Problem 4 Golf Pointers Solution
Language:  Python 3.x
Author:  Mark Fienup
NOTE:  READ_FILE = False means read from standard input; True means read from file.
NOTE:  WRITE_FILE = False means write to standard output; True means write to file.
"""
import sys

READ_FILE = False
IN_FILE_OPENED = False
IN_FILE_NAME = "prob4_in.txt"
IN_FILE = None

WRITE_FILE = False
OUT_FILE_OPENED = False
OUT_FILE_NAME = "prob4_out.txt"
OUT_FILE = None

def main():
    directionsToLeft =  ["N","NtW","NbW","NNWtN","NNW","NNWtW","NWbN","NWtN","NW","NWtW","NWbW","WNWtN","WNW","WNWtW","WbN","WtN", "W"]
    directionsToRight = ["N","NtE","NbE","NNEtN","NNE","NNEtE","NEbN","NEtN","NE","NEtE","NEbE","ENEtN","ENE","ENEtE","EbN","EtN", "E"]
    
    numberOfCases = int(nextLine())
    #print(numberOfCases)
    for case in range(1, numberOfCases+1):
        directionInfo = nextLine().split()
        degrees = int(directionInfo[0])
        leftOrRight = directionInfo[4].lower()
        index = round(degrees/5.625)
        if leftOrRight == "left":
            direction = directionsToLeft[index]
        else:
            direction = directionsToRight[index]
            
        resultStr = "Case " + str(case) + ":"
        resultStr += " " + direction
        writeLine(resultStr)

    if WRITE_FILE:
        OUT_FILE.close()

def writeLine(line):
    global OUT_FILE_OPENED
    global OUT_FILE
    if WRITE_FILE:
        if not OUT_FILE_OPENED:
            OUT_FILE = open(OUT_FILE_NAME, "w")
            OUT_FILE_OPENED = True
        OUT_FILE.write(line+"\n")
    else:
        print(line)


def nextLine():
    global IN_FILE_OPENED
    global IN_FILE
    if READ_FILE:
        if not IN_FILE_OPENED:
            IN_FILE = open(IN_FILE_NAME, "r")
            IN_FILE_OPENED = True
        line = IN_FILE.readline().strip()
    else:
        line = input()
    return line
            

main()
