"""
Problem 5 MICS L Solution
Language:  Python 3.x
Author:  Mark Fienup
NOTE:  READ_FILE = False means read from standard input; True means read from file.
NOTE:  WRITE_FILE = False means write to standard output; True means write to file.
"""
import sys

READ_FILE = False
IN_FILE_OPENED = False
IN_FILE_NAME = "prob5_in.txt"
IN_FILE = None

WRITE_FILE = False
OUT_FILE_OPENED = False
OUT_FILE_NAME = "prob5_out.txt"
OUT_FILE = None

def main():
   
    numberOfCases = int(nextLine())
    #print(numberOfCases)
    for case in range(1, numberOfCases+1):
        caseStr = "Case " + str(case) + ":"
        writeLine(caseStr)
        
        scale = int(nextLine())
        #print M |
        printM(scale)
        #print   |
        printGap(scale)
        #print I |
        printI(scale)
        #print   |
        printGap(scale)
        #print C |
        printC(scale)
        #print   |
        printGap(scale)
        #print S |__
        printS(scale)
        
    if WRITE_FILE:
        OUT_FILE.close()

def printGap(scale):
    for count in range(scale):  # gap between letters
        line = ""
        line += " "*(10*scale)
        line += "L"*scale
        line += " "*(scale*19)
        
        writeLine(line)

def printC(scale):
    for count in range(scale):  # top of C
        line = ""
        line += "C"*scale*5
        line += " "*scale*5
        line += "L"*scale
        line += " "*(scale*19)
        writeLine(line)
        
    for count in range(scale*3):  #middle of C
        line = ""
        line += "C"*scale
        line += " "*scale*9
        line += "L"*scale
        line += " "*(scale*19)
        writeLine(line)
        
    for count in range(scale):  # bottom of C
        line = ""
        line += "C"*scale*5
        line += " "*scale*5
        line += "L"*scale
        line += " "*(scale*19)
        writeLine(line)

def printS(scale):
    for count in range(scale):  # top of S
        line = ""
        line += "S"*scale*5
        line += " "*scale*5
        line += "L"*scale
        line += " "*(scale*19)
        writeLine(line)
        
    for count in range(scale):  #top 2/5th of S
        line = ""
        line += "S"*scale
        line += " "*scale*4
        line += " "*scale*5
        line += "L"*scale
        line += " "*(scale*19)
        writeLine(line)
        
    for count in range(scale):  # middle of S
        line = ""
        line += "S"*scale*5
        line += " "*scale*5
        line += "L"*scale
        line += " "*(scale*19)
        writeLine(line)
        
    for count in range(scale):  #top 4/5th of S
        line = ""
        line += " "*scale*4
        line += "S"*scale
        line += " "*scale*5
        line += "L"*scale
        line += " "*(scale*19)
        writeLine(line)
        
    for count in range(scale):  # bottom of S
        line = ""
        line += "S"*scale*5
        line += " "*scale*5
        line += "L"*scale*20
        writeLine(line)

def printI(scale):
    for count in range(scale):  # top of I
        line = ""
        line += "I"*scale*5
        line += " "*scale*5
        line += "L"*scale
        line += " "*(scale*19)
        writeLine(line)
        
    for count in range(scale*3):  #middle of I
        line = ""
        line += " "*scale*2
        line += "I"*scale
        line += " "*scale*2
        line += " "*scale*5
        line += "L"*scale
        line += " "*(scale*19)
        writeLine(line)
        
    for count in range(scale):  # bottom of I
        line = ""
        line += "I"*scale*5
        line += " "*scale*5
        line += "L"*scale
        line += " "*(scale*19)
        writeLine(line)

def printM(scale):
    spacesBetween = (scale*3)
    for count in range(scale+2-1):  # Top of M
        line = ""
        line += "M"*scale

        line += " "*(count-scale)
        line += "M"*min(count, scale)
        line += " "*spacesBetween

        line += "M"*min(count, scale)
        line += " "*(count-scale)

        line += "M"*scale
        line += " "*scale*5
        line += "L"*scale
        line += " "*(scale*19)
        
        writeLine(line)
        spacesBetween -= 2

    spacesBetween = 1
    MsBetween = scale*5 - 2*scale - 2*spacesBetween
    for count2 in range(count, (scale*5-1)//2):  # Middle of M
        line = ""
        line += "M"*scale

        line += " "*spacesBetween
        line += "M"*MsBetween
        line += " "*spacesBetween

        line += "M"*scale
        line += " "*scale*5
        line += "L"*scale
        line += " "*(scale*19)
        
        writeLine(line)
        spacesBetween +=1
        MsBetween -= 2

    for count in range((scale*5)//2):  # Bottom half of M
        line = ""
        line += "M"*scale

        line += " "*(3*scale)
        line += "M"*scale
        line += " "*scale*5
        line += "L"*scale
        line += " "*(scale*19)
        
        writeLine(line)

def writeLine(line):
    global OUT_FILE_OPENED
    global OUT_FILE
    if WRITE_FILE:
        if not OUT_FILE_OPENED:
            OUT_FILE = open(OUT_FILE_NAME, "w")
            OUT_FILE_OPENED = True
        OUT_FILE.write(line+"\n")
    else:
        print(line)


def nextLine():
    global IN_FILE_OPENED
    global IN_FILE
    if READ_FILE:
        if not IN_FILE_OPENED:
            IN_FILE = open(IN_FILE_NAME, "r")
            IN_FILE_OPENED = True
        line = IN_FILE.readline().strip()
    else:
        line = input()
    return line
            

main()
