"""
Problem 6 Odd-Even Directional Sort Solution
Language:  Python 3.x
Author:  Mark Fienup
NOTE:  READ_FILE = False means read from standard input; True means read from file.
NOTE:  WRITE_FILE = False means write to standard output; True means write to file.
"""
import sys

READ_FILE = False
IN_FILE_OPENED = False
IN_FILE_NAME = "prob6_in.txt"
IN_FILE = None

WRITE_FILE = False
OUT_FILE_OPENED = False
OUT_FILE_NAME = "prob6_out.txt"
OUT_FILE = None

def main():
  
    numberOfCases = int(nextLine())
    #print(numberOfCases)
    
    for case in range(1, numberOfCases+1):
        sortInfo = nextLine().split()
        numberOfValues = int(sortInfo[0])
        oddValues = []
        evenValues = []
        for index in range(1, numberOfValues+1):
            value = int(sortInfo[index])
            sortInfo[index] = value
            if value % 2 == 0:  # even integer
                evenValues.append(value)
            else:
                oddValues.append(value)
        oddValues.sort() #sort in ascending order
        evenValues.sort(reverse=True) #sort in descending order
            
        resultStr = "Case " + str(case) + ":"
        nextOddAt = 0
        nextEvenAt = 0
        for index in range(1,numberOfValues+1):
            if sortInfo[index] % 2 == 0:
                resultStr += " " + str(evenValues[nextEvenAt])
                nextEvenAt += 1
            else:
                resultStr += " " + str(oddValues[nextOddAt])
                nextOddAt += 1
                
        writeLine(resultStr)

    if WRITE_FILE:
        OUT_FILE.close()

def writeLine(line):
    global OUT_FILE_OPENED
    global OUT_FILE
    if WRITE_FILE:
        if not OUT_FILE_OPENED:
            OUT_FILE = open(OUT_FILE_NAME, "w")
            OUT_FILE_OPENED = True
        OUT_FILE.write(line+"\n")
    else:
        print(line)


def nextLine():
    global IN_FILE_OPENED
    global IN_FILE
    if READ_FILE:
        if not IN_FILE_OPENED:
            IN_FILE = open(IN_FILE_NAME, "r")
            IN_FILE_OPENED = True
        line = IN_FILE.readline().strip()
    else:
        line = input()
    return line
            

main()
