"""
Problem 8 Wandering Mind Solution
Language:  Python 3.x
Author:  Mark Fienup
NOTE:  READ_FILE = False means read from standard input; True means read from file.
NOTE:  WRITE_FILE = False means write to standard output; True means write to file.
"""
import sys

READ_FILE = False
IN_FILE_OPENED = False
IN_FILE_NAME = "prob8_in.txt"
IN_FILE = None

WRITE_FILE = False
OUT_FILE_OPENED = False
OUT_FILE_NAME = "prob8_out.txt"
OUT_FILE = None

def main():
  
    numberOfCases = int(nextLine())
    #print(numberOfCases)
    
    for case in range(1, numberOfCases+1):
        n = int(nextLine().strip())
           
        resultStr = "Case " + str(case) + ":"
        resultStr += " " + str(F(n))
                
        writeLine(resultStr)

    if WRITE_FILE:
        OUT_FILE.close()

def F(n):
    if n < 10:
        return F_recursive(n)
    else:
        f_values = []
        for i in range(10):
            f_values.append(F_recursive(i))
        for i in range(10, n+1):
            f_values.append(f_values[i-6]+f_values[i-4]+f_values[i-1])
        return f_values[n]
    
    
def F_recursive(n):
    if n <= -3:
        return n
    elif n < 3:
        return 2*n
    else:
        return F(n-6) + F(n-4) + F(n-1)


def writeLine(line):
    global OUT_FILE_OPENED
    global OUT_FILE
    if WRITE_FILE:
        if not OUT_FILE_OPENED:
            OUT_FILE = open(OUT_FILE_NAME, "w")
            OUT_FILE_OPENED = True
        OUT_FILE.write(line+"\n")
    else:
        print(line)


def nextLine():
    global IN_FILE_OPENED
    global IN_FILE
    if READ_FILE:
        if not IN_FILE_OPENED:
            IN_FILE = open(IN_FILE_NAME, "r")
            IN_FILE_OPENED = True
        line = IN_FILE.readline().strip()
    else:
        line = input()
    return line
            

main()
