"""
Problem 9 Secret Message Solution
Language:  Python 3.x
Author:  Mark Fienup
NOTE:  READ_FILE = False means read from standard input; True means read from file.
NOTE:  WRITE_FILE = False means write to standard output; True means write to file.
"""
import sys

READ_FILE = False
IN_FILE_OPENED = False
IN_FILE_NAME = "prob9_in.txt"
IN_FILE = None

WRITE_FILE = False
OUT_FILE_OPENED = False
OUT_FILE_NAME = "prob9_out.txt"
OUT_FILE = None

def main():
    shiftAmt = int(nextLine())
    #charSeq = "aA0bB1cC2dD3eE4fF5gG6hH7iI8jJ9kK lL,mM.nN?oO/pP;qQ:rR'sS\"tT!uU@vV$wW%xX&yY-zZ="
    charSeq = nextLine()
    numberOfLines = int(nextLine())
    
    # Builds dictionary to convert from a character to a position efficiently
    charPositionDict = {}
    index = 0
    for char in charSeq:
        charPositionDict[char] = index
        index += 1

    length = len(charSeq)
    shiftAmt = shiftAmt % length
 
    for count in range(numberOfLines):
        line = nextLine()
        decryptedLine = ""
        for char in line:
            if char in charSeq:
                position = charPositionDict[char]
                shiftPosition = position - shiftAmt
                if shiftPosition < 0:
                    shiftPosition = shiftPosition + length
                decryptedChar = charSeq[shiftPosition]
                decryptedLine += decryptedChar
                shiftAmt = charPositionDict[decryptedChar]
            else:
                decryptedLine += char
        writeLine(decryptedLine)
    if WRITE_FILE:
        OUT_FILE.close()


def writeLine(line):
    global OUT_FILE_OPENED
    global OUT_FILE
    if WRITE_FILE:
        if not OUT_FILE_OPENED:
            OUT_FILE = open(OUT_FILE_NAME, "w")
            OUT_FILE_OPENED = True
        OUT_FILE.write(line+"\n")
    else:
        print(line)


def nextLine():
    global IN_FILE_OPENED
    global IN_FILE
    if READ_FILE:
        if not IN_FILE_OPENED:
            IN_FILE = open(IN_FILE_NAME, "r")
            IN_FILE_OPENED = True
        line = IN_FILE.readline().strip('\n')
    else:
        line = input()
    return line
            

main()
